/**
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
#pragma once

#include "SwaggerBaseModel.h"
#include "SwaggerDepositApi.h"

#include "SwaggerDeposit.h"
#include "SwaggerDepositCompleteResponse.h"
#include "SwaggerDepositTransferResponse.h"
#include "SwaggerError.h"

namespace Swagger 
{

/* 개별 입금 주소 조회
 *
 * ## 개별 입금 주소 조회 **NOTE**: 입금 주소 조회 요청 API 유의사항 입금 주소 생성 요청 이후 아직 발급되지 않은 상태일 경우 deposit_address가 null일 수 있습니다. 
*/
class SWAGGER_API SwaggerDepositApi::DepositCoinAddressRequest : public Request
{
public:
    virtual ~DepositCoinAddressRequest() {}
	void SetupHttpRequest(const TSharedRef<IHttpRequest>& HttpRequest) const final;
	FString ComputePath() const final;
    
	/* Currency symbol  */
	FString Currency;
};

class SWAGGER_API SwaggerDepositApi::DepositCoinAddressResponse : public Response
{
public:
    virtual ~DepositCoinAddressResponse() {}
	void SetHttpResponseCode(EHttpResponseCodes::Type InHttpResponseCode) final;
	bool FromJson(const TSharedPtr<FJsonValue>& JsonObject) final;
    
    SwaggerDepositCompleteResponse Content;
};

/* 전체 입금 주소 조회
 *
 * ## 내가 보유한 자산 리스트를 보여줍니다. **NOTE**: 입금 주소 조회 요청 API 유의사항 입금 주소 생성 요청 이후 아직 발급되지 않은 상태일 경우 deposit_address가 null일 수 있습니다. 
*/
class SWAGGER_API SwaggerDepositApi::DepositCoinAddressesRequest : public Request
{
public:
    virtual ~DepositCoinAddressesRequest() {}
	void SetupHttpRequest(const TSharedRef<IHttpRequest>& HttpRequest) const final;
	FString ComputePath() const final;
    
};

class SWAGGER_API SwaggerDepositApi::DepositCoinAddressesResponse : public Response
{
public:
    virtual ~DepositCoinAddressesResponse() {}
	void SetHttpResponseCode(EHttpResponseCodes::Type InHttpResponseCode) final;
	bool FromJson(const TSharedPtr<FJsonValue>& JsonObject) final;
    
    TSharedPtr<FJsonObject> Content;
};

/* 입금 주소 생성 요청
 *
 * 입금 주소 생성을 요청한다. **NOTE**: 입금 주소 생성 요청 API 유의사항 입금 주소의 생성은 서버에서 비동기적으로 이뤄집니다. 비동기적 생성 특성상 요청과 동시에 입금 주소가 발급되지 않을 수 있습니다. 주소 발급 요청 시 결과로 Response1이 반환되며 주소 발급 완료 이전까지 계속 Response1이 반환됩니다. 주소가 발급된 이후부터는 새로운 주소가 발급되는 것이 아닌 이전에 발급된 주소가 Response2 형태로 반환됩니다. 정상적으로 주소가 생성되지 않는다면 일정 시간 이후 해당 API를 다시 호출해주시길 부탁드립니다. 
*/
class SWAGGER_API SwaggerDepositApi::DepositGenerateCoinAddressRequest : public Request
{
public:
    virtual ~DepositGenerateCoinAddressRequest() {}
	void SetupHttpRequest(const TSharedRef<IHttpRequest>& HttpRequest) const final;
	FString ComputePath() const final;
    
	/* Currency 코드  */
	FString Currency;
};

class SWAGGER_API SwaggerDepositApi::DepositGenerateCoinAddressResponse : public Response
{
public:
    virtual ~DepositGenerateCoinAddressResponse() {}
	void SetHttpResponseCode(EHttpResponseCodes::Type InHttpResponseCode) final;
	bool FromJson(const TSharedPtr<FJsonValue>& JsonObject) final;
    
    SwaggerDepositCompleteResponse Content;
};

/* 개별 입금 조회
 *
 * ## 개별 입금 조회 
*/
class SWAGGER_API SwaggerDepositApi::DepositInfoRequest : public Request
{
public:
    virtual ~DepositInfoRequest() {}
	void SetupHttpRequest(const TSharedRef<IHttpRequest>& HttpRequest) const final;
	FString ComputePath() const final;
    
	/* 입금 UUID  */
	TOptional<FString> Uuid;
	/* 입금 TXID  */
	TOptional<FString> Txid;
	/* Currency 코드  */
	TOptional<FString> Currency;
};

class SWAGGER_API SwaggerDepositApi::DepositInfoResponse : public Response
{
public:
    virtual ~DepositInfoResponse() {}
	void SetHttpResponseCode(EHttpResponseCodes::Type InHttpResponseCode) final;
	bool FromJson(const TSharedPtr<FJsonValue>& JsonObject) final;
    
    SwaggerDeposit Content;
};

/* 입금 리스트 조회
 *
 * ## 입금 리스트 조회 
*/
class SWAGGER_API SwaggerDepositApi::DepositInfoAllRequest : public Request
{
public:
    virtual ~DepositInfoAllRequest() {}
	void SetupHttpRequest(const TSharedRef<IHttpRequest>& HttpRequest) const final;
	FString ComputePath() const final;
    
	/* Currency 코드  */
	TOptional<FString> Currency;
	/* 출금 상태 - submitting : 처리 중 - submitted : 처리완료 - almost_accepted : 입금 대기 중 - rejected : 거절 - accepted : 승인됨 - processing : 처리 중  */
	TOptional<FString> State;
	/* 입금 UUID의 목록  */
	TOptional<TArray<FString>> Uuids;
	/* 입금 TXID의 목록  */
	TOptional<TArray<FString>> Txids;
	/* 개수 제한 (default: 100, max: 100)  */
	TOptional<double> Limit;
	/* 페이지 수, default: 1  */
	TOptional<double> Page;
	/* 정렬 방식 - asc : 오름차순 - desc : 내림차순 (default)  */
	TOptional<FString> OrderBy;
};

class SWAGGER_API SwaggerDepositApi::DepositInfoAllResponse : public Response
{
public:
    virtual ~DepositInfoAllResponse() {}
	void SetHttpResponseCode(EHttpResponseCodes::Type InHttpResponseCode) final;
	bool FromJson(const TSharedPtr<FJsonValue>& JsonObject) final;
    
    TArray<SwaggerDeposit> Content;
};

}
